<template>
  <div>
    <DoughnutChart
      :chart-data="datacollection"
      :options="options"
      :height="300"
    />
  </div>
</template>
<script>
import DoughnutChart from '@/components/chart/doughnut.js'
import covertDate from '@/mixins/formateDate'
import axios from 'axios'
export default {
  mixins: [covertDate],
  components: {
    DoughnutChart,
  },
  props: {
    setDataDate: Number,
  },
  data() {
    return {
      datacollection: null,
      loaded: false,
      dataTotal: [],
      dataLabels: [],
      dataBGColor: [],
      options: null,
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    setDataDate(newVal, oldVal) {
      this.getDataAxios(
        this.setDataDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.dataLabels,
        datasets: [
          {
            label: ['ค่าใช้จ่ายรายวัน'],
            data: this.dataTotal,
            backgroundColor: this.dataBGColor,
            borderColor: ['#FFF'],
            borderWidth: 1,
          },
        ],
      }
      this.options = {
        responsive: true,
        title: {
          display: true,
          text: 'Custom Chart Title',
          position: 'Top',
        },
        animation: {
          animateScale: true,
          animateRotate: true,
        },
        tooltip: {
          trigger: 'item',
          formatter: '{a} <br/>{b} : {c} ({d}%)',
        },
        legend: {
          position: 'left',
          labels: {
            fontColor: 'rgb(154, 154, 154)',
            fontSize: 11,
            usePointStyle: true,
            padding: 20,
          },
        },
        cutoutPercentage: 50,
        labels: {
          showActualPercentages: true,
        },
        responsive: true,
        maintainAspectRatio: false,
        plugins: {
          // Change options for ALL labels of THIS CHART
          // labels: {
          //   render: 'percentage',
          //   fontColor: ['green', 'white', 'red'],
          //   precision: 2,
          // },
          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
      }
    },
    async getDataAxios(
      timeVal = new Date().getTime(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const getDate = timeVal

        const dataRes = this.totalTypeMulti(expensestable, getDate, getDate)

        this.dataLabels = expensestype.map((x) => x.name)
        const countName = expensestype.map((x) => x.name).length

        this.dataTotal = this.setArray(dataRes, countName)

        this.dataBGColor = this.setObjectBG(countName)

        this.fillData()
      }
    },
    setArray(dataObject, countName) {
      const arrayDeserts = new Array(countName)

      for (let i = 0; i < countName; i++) {
        dataObject.forEach((res) => {
          if (res.id - 1 == i) {
            if (arrayDeserts[i] > 0) {
              arrayDeserts[i] = arrayDeserts[i] + res.price
            } else {
              arrayDeserts[i] = res.price
            }
          }
        })
        if (arrayDeserts[i] == null) {
          arrayDeserts[i] = ''
        }
      }
      return arrayDeserts
    },
  },
}
</script>
